/********************************************************************
	created:	2004/10/02
	created:	2:10:2004   0:06
	filename: 	c:\binary\Client\Sde\CDXBitmap.cpp
	file path:	c:\binary\Client\Sde
	file base:	CDXBitmap
	file ext:	cpp
	author:		
	
	purpose:	
*********************************************************************/

#include "CDXBitmap.h"
#include "resource.h"

OUT const bool
CDXBitmap::LoadFromFile( IN LPDIRECT3DDEVICE9 pDevice, IN CDC* pDC, IN const char *pFilename, IN const int width, IN const int height )
{
	if( pFilename == NULL || pDevice == NULL )
		return false;

	LPDIRECT3DTEXTURE9 pTexture( NULL );
	D3DXCreateTextureFromFileEx( pDevice, pFilename, width, height, 0, 0, D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, D3DX_DEFAULT, D3DX_DEFAULT, 0, NULL, NULL, &pTexture );

	if( pTexture == NULL )
		return false;

	D3DLOCKED_RECT lockRect;
	D3DSURFACE_DESC desc;

	pTexture->GetLevelDesc( 0, &desc );

	pTexture->LockRect( 0, &lockRect, NULL, D3DLOCK_READONLY );
	if( lockRect.pBits == NULL )
	{
		pTexture->UnlockRect( 0 );
		return false;
	}

	BYTE *pPixel = (BYTE *)lockRect.pBits;
	register DWORD r, g, b, a;

	BYTE *pImage = new BYTE[ desc.Width * desc.Height * 3 ];//(BYTE *)m_hObject + sizeof(BITMAPINFOHEADER);
	BYTE *pDest = pImage;

	for( size_t y = 0; y < desc.Height; y++ )
	{
		for( size_t x = 0; x < desc.Width; x++ )
		{
			r = *pPixel++;
			g = *pPixel++;
			b = *pPixel++;
			a = *pPixel++;
			
			*pDest++ = (BYTE)( r * a / 255 );
			*pDest++ = (BYTE)( g * a / 255 );
			*pDest++ = (BYTE)( b * a / 255 );
		}
	}

	BITMAPINFOHEADER bi;
	bi.biSize            = sizeof(BITMAPINFOHEADER) ;
	bi.biWidth           = desc.Width;
	bi.biHeight          = desc.Height;
	bi.biPlanes          = 1;
	bi.biBitCount        = 24;
	bi.biCompression     = BI_RGB ;
	bi.biSizeImage       = desc.Width * desc.Height;
	bi.biXPelsPerMeter   = 0 ;
	bi.biYPelsPerMeter   = 0 ;
	bi.biClrUsed         = 0 ;
	bi.biClrImportant    = 0 ;

	Attach( CreateDIBitmap( pDC->GetSafeHdc(), &bi, (LONG)CBM_INIT, pImage, (LPBITMAPINFO)&bi, DIB_RGB_COLORS ) );

	delete []pImage;

	pTexture->UnlockRect( 0 );
	pTexture->Release();

	return true;
}
